' Thanks to "X" for the original design.
'
'   Created by: X
'   E-Mail: mailto:createdbyx@yahoo.com
'   Web: http://www.createdbyx.com/
'   Date: Thursday, December 19, 2002
'
' Modified and cleaned up by Bob Dugan 11/16/2005 to convert
' example into a soundplayer class.
Imports Microsoft.DirectX

Public Class SoundPlayer

    Private device As DirectSound.Device
    Private buffer As DirectSound.Buffer
    Private soundFileName As String

    Public Sub New(ByVal valueOwnerForm As Windows.Forms.Form, ByVal valueSoundFileName As String)
        device = New DirectSound.Device
        device.SetCooperativeLevel(valueOwnerForm, DirectSound.CooperativeLevel.Normal)
        setSoundFileName(valueSoundFileName)
    End Sub

    Public Sub setSoundFileName(ByVal value As String)
        soundFileName = value
    End Sub

    Public Function getSoundFileName() As String
        getSoundFileName = soundFileName
    End Function

    Public Sub play()
        Try

            ' Get rid of the old sound buffer
            If (Not (buffer Is Nothing)) Then
                buffer.Stop()
                buffer.Dispose()
                buffer = Nothing
            End If

            ' Create the new sound buffer
            Dim waveFormat As DirectSound.WaveFormat
            Dim bufferDescription As New DirectSound.BufferDescription(waveFormat)
            bufferDescription.ControlVolume = True
            buffer = New DirectSound.Buffer(soundFileName, bufferDescription, device)

            ' Play the new sound buffer
            buffer.Stop()
            buffer.SetCurrentPosition(0)
            buffer.Play(0, DirectSound.BufferPlayFlags.Default)

        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Sub

    Public Sub halt()
        Try
            If (Not (buffer Is Nothing)) Then
                buffer.Stop()
                buffer.SetCurrentPosition(0)
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Protected Overrides Sub Finalize()

        ' Get rid of the old sound buffer
        If (Not (buffer Is Nothing)) Then
            buffer.Stop()
            buffer.Dispose()
            buffer = Nothing
        End If

        device.Dispose()
        device = Nothing
    End Sub


End Class
